/*******************************************************************
  Windows NT/2000/XP service designed for CircleMUD (any version)

     This will allow you to run CircleMUD as a system service, and
  also functions as an "autorun script" to boot. It will recognize
  what type of shutdown was initiated by what file CircleMUD has
  created (using the touch() function) and will act accordingly.

  Command-line syntax:

  > circlesv.exe -i        (installs system service)
  > circlesv.exe -r        (removes system service)
  

  Use this program and source as you will, no credit needs be
  mentioned on your MUD's website (though it would be really neat!)
  and this stuff up here doesn't even have to remain intact, heh.

  --Craig Mackles (cmackles@msn.com)

  ******************************************************************/

#include <windows.h>
#include <conio.h>
#include <stdio.h>

SERVICE_STATUS_HANDLE		sHandle;
SERVICE_STATUS				status;


/*
   This little thinger tells the system what to do when you click
   something on the services control applet
*/
void WINAPI ServiceCtrlHandler(DWORD control)
{
	switch(control)
	{
		case SERVICE_CONTROL_SHUTDOWN:
		case SERVICE_CONTROL_STOP:
			status.dwCurrentState = SERVICE_STOPPED;
			status.dwWin32ExitCode = 0;
			status.dwCheckPoint = 0;
			status.dwWaitHint = 0;
			break;
		case SERVICE_CONTROL_INTERROGATE:
			break;
	}
	::SetServiceStatus(sHandle, &status);
}


/* This dispatches service stuff. Gets the ball rolling. */
void WINAPI ServiceDispatch(DWORD numArgs, char **args)
{
	memset( &status, 0, sizeof(SERVICE_STATUS));
	status.dwServiceType = SERVICE_WIN32;
	status.dwCurrentState = SERVICE_START_PENDING;
	status.dwControlsAccepted = SERVICE_ACCEPT_STOP;

	sHandle = ::RegisterServiceCtrlHandler("CircleMUD", &ServiceCtrlHandler);

	::SetServiceStatus(sHandle, &status);
}

/*
  The big kahuna. This does most of the grunt work of our program,
  and is actually required if it's a console app. For some reason
  WinMain() isn't even considered, and the compiler will spit out
  an error when it goes to link if this function doesn't exist...
  even if you have a WinMain() established, it still whines. Go
  figure.
*/
int main(int argc, char **argv)
{
	FILE	*fl;		/* For determining if .killscript and friends exist */
	int		pos = 1;	/* For parsing our command line arguments */

	/* Giving the service a handle to go by */
	SC_HANDLE handle = ::OpenSCManager(NULL, NULL, SC_MANAGER_ALL_ACCESS);

	/* Scan the whole command line from start to finish, and look for hyphens */
	while((pos < argc) && (*(argv[pos]) == '-'))
	{
		/* The -i switch tells us to install the service */
		if (*(argv[pos] + 1) == 'i')
		{
			/* Create the service using, well, ::CreateService() */
			SC_HANDLE service = ::CreateService(
					handle,								// The handle we specified above
					"CircleMUD",						// The internal name for the service
					"CircleMUD",						// Service name shown in the Services list
					GENERIC_READ | GENERIC_EXECUTE,		// Desired access - Just read and execute
					SERVICE_WIN32_OWN_PROCESS,			// Service type - Start its own process
					SERVICE_AUTO_START,					// Startup type - Autostart with Windows
					SERVICE_ERROR_IGNORE,				// Error control - Ignore errors and just
														//                 kill the program
					"C:\\circle\\circlesv.exe",			// Path to THIS program
					NULL, NULL, NULL, NULL, NULL);

			printf("Service installed successfully.\r\n");
			return 1;
		}
		/* And the -r switch tells us to remove it */
		else if (*(argv[pos] + 1) == 'r')
		{
			/* And if we want to remove the service... */

			/* We find the service... */
			SC_HANDLE service = ::OpenService(handle, "CircleMUD", DELETE);

			/* If the service is there... (not NULL) */
			if(service != NULL)
			{
				/* ...then we KILL IT! */
				::DeleteService(service);
				printf("Service removed successfully.\r\n");
			}
			else
				/* ...otherwise tell 'em it wasn't there in the first place. */
				printf("The service did not exist.\r\n");
			return 1;
		}
	}

	/* ...otherwise, just run the game */

startCircle:
	/* This is the path to the CircleMUD executable file */
	system("C:\\circle\\circle.exe"); 

	/* I know this looks ugly, but hey, it's easy. */
	if(fl = fopen(".killscript", "r"))
	{
		/* Kill the whole shabbang */
		printf("KILLSCRIPT detected; killing autorun.\r\n");
		printf("Stopping the service...");
		ServiceCtrlHandler(SERVICE_CONTROL_STOP);
		printf("done.\r\n");
		printf("Exiting program.\r\n");
		fclose(fl);
		exit(0);
	}
	else if(fl = fopen(".fastboot", "r"))
		/* Quick! Start the sucker back up! */
		goto startCircle;
	else if(fl = fopen("pause", "r"))
	{
		/* Pretty self-explanatory, huh? */
		fclose(fl);
		printf("PAUSE detected; freezing autorun.\r\n");
		printf("**PRESS ANY KEY TO RESTART THE MUD**");
		getch();
		goto startCircle;
	}
	else
	{
		/* Uh oh... something screwed up with CircleMUD... */
		printf("Abnormal shutdown detected; killing autorun.\r\n");
		printf("Stopping the service...");
		ServiceCtrlHandler(SERVICE_CONTROL_STOP);
		printf("done.\r\n");
		printf("Exiting program.\r\n");
		fclose(fl);
		exit(0);
	}

	/* We should never get here... */
	return 0;
}